#include "PainterEngine_Application.h"
PX_Application App;

PX_Object* root,*executer,*asmdebugger;
px_bool PX_ApplicationInitialize(PX_Application *pApp,px_int screen_width,px_int screen_height)
{
	PX_IO_Data data = PX_LoadFileToIOData("test.c");
	PX_ApplicationInitializeDefault(&pApp->runtime, screen_width, screen_height);
	root = PX_ObjectCreate(&pApp->runtime.mp_game, 0, 0, 0, 0, 0, 0, 0);
	executer=PX_Object_ExecuterCreate(&pApp->runtime.mp_game, root, 0, 0, pApp->runtime.surface_width/2, pApp->runtime.surface_height, PX_NULL, data.buffer);
	asmdebugger = PX_Object_AsmDebuggerCreate(&pApp->runtime.mp_game, root, pApp->runtime.surface_width / 2, 0,
		pApp->runtime.surface_width / 2, pApp->runtime.surface_height, PX_Object_ExecuterGetDebugMap(executer), PX_Object_ExecuterGetVM(executer), PX_NULL);
	return PX_TRUE;
}

px_void PX_ApplicationUpdate(PX_Application *pApp,px_dword elapsed)
{
	PX_ObjectUpdate(root, elapsed);
}

px_void PX_ApplicationRender(PX_Application *pApp,px_dword elapsed)
{
	px_surface *pRenderSurface=&pApp->runtime.RenderSurface;
	PX_RuntimeRenderClear(&pApp->runtime,PX_OBJECT_UI_DEFAULT_BACKGROUNDCOLOR);
	PX_ObjectRender(pRenderSurface, root, elapsed);
}

px_void PX_ApplicationPostEvent(PX_Application *pApp,PX_Object_Event e)
{
	PX_ApplicationEventDefault(&pApp->runtime, e);
	PX_ObjectPostEvent(root, e);
}

